#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define NUM_ROUNDS	1000

static void print_duration(const char *msg, struct timespec *tstart, struct timespec *tend)
{
	long nsec_start;
	long nsec_end;

	nsec_start = 1000*1000*1000*tstart->tv_sec + tstart->tv_nsec;
	nsec_end = 1000*1000*1000*tend->tv_sec + tend->tv_nsec;

	printf("%s (ns): %ld\n", msg, nsec_end-nsec_start);
}

static void get_time(struct timespec *time_ptr)
{
	if (clock_gettime(CLOCK_REALTIME, time_ptr) < 0) {
		perror("clock_gettime");
		exit(EXIT_FAILURE);
	}
}

int main(void)
{
	size_t i;
	struct timespec tstart, tend;
	struct timespec one_us = {
		.tv_sec = 0,
		.tv_nsec = 1000 * 1000
	};

	get_time(&tstart);
	/* Sleep for NUM_ROUNDS milliseconds. */
	for (i = 0; i < NUM_ROUNDS; i++)
		nanosleep(&one_us, NULL);
	get_time(&tend);

	print_duration("Sleep time", &tstart, &tend);

	return 0;
}
